R.Wobst  21.04.88


      Ergaenzungen und Aenderungen zur Dokumentation von
      ==================================================

                Pretty C - Version 1.1
                ======================


Zum Speicherbedarf:
-------------------

- Quelltextfiles duerfen erst ab 5300H beginnen (und nicht ab
  5200H wie angegeben). Dann ist jedoch keine Uebersetzung mehr
  moeglich, d.h. es kann nur mit dem Editor gearbeitet werden.

- Die Laengen von CLIB und CLIBM (und des erzeugten Codes) aendern
  sich z.Z. noch und sind kuerzer als angegeben. Sie sind mit den
  Kommandos EC /DI und CC /DS zu ermitteln.


Zu 1.0
------

Als weiteres Kommando ist noch

CHS

implementiert worden ("checksum"). Vom Compiler wird eine Pruef-
summe errechnet und als vierstellige Hexadezimalzahl ausgegeben.
Diese Zahl darf sich  n a c h  einer Installierung nicht mehr aen-
dern.
Damit kann der Nutzer kontrollieren, ob durch Programmfehler ver-
sehentlich der Compiler ueberschrieben wurde.


Zu 3.3.5
--------

Die Variable 'val' hat den Typ 'unsigned *' und nicht 'char *'.


Zu 6.2
------

Die arcsin-Funktion heisst 'asin' und nicht 'arcsin'.


Zu 8.1, Punkt 1
---------------

Auch die Funktion '_debvd' ist reserviert.


Zu 8.2
------

- Zusaetzlich wurde das Kommando 'd' (delete) aufgenommen, das
  das letzte f-Kommando rueckgaengig macht. Durch wiederholte An-
  wendung des d-Kommandos koennen so nacheinander alle Anzeigen
  von Variablen geloescht werden.

- Die Anzahl der angezeigten Quelltextzeilen ist vorgegeben.
  Sind jedoch einzelne Zeilen laenger als 4O Zeichen, so wird
  das Bildschirmfenster fuer den Quelltext entsprechend groesser.
  Bei nachfolgender Kontraktion dieses Fensters bleiben Teile der
  alten Begrenzung erhalten. Das sollte nicht stoeren.

- Wird der gerade angezeigte Wert mit dem 'w'-Kommando veraendert,
  so kann das unbeabsichtigte Nebenwirkungen haben. Der Wert muss
  naemlich nicht in einer Zelle fuer Zwischenergebnisse stehen,
  d.h. man kann auf diese Weise Variablen oder sogar Konstanten
  veraendern!

  Beispiele:
    Die angezeigte Anweisung sei
    while (a+b) ...
    Das Ergebnis 'a+b' steht in einer Stackzelle fuer Zwischen-
    ergebnisse, seine Veraenderung hat hoechstens auf seine Aus-
    wertung in der while-Bedingung EinflusS.
    Wird dagegen
    if(a) ...
    angezeigt, so veraendert 'w'-Nr.0 gleichzeitig die Variable a.
    Und in
    putchar('\n');
    darf man das Argument '\n' keinesfalls veraendern, da sonst
    die Konstante 'newline' ueberschrieben wird.
  Also: VORSICHT!


Zu 8.3
------

Durch Vergroesserung bzw. Verkleinerung des Wertes fuer die sym-
bolische Konstante ANIM kann der 'animation mode' verlangsamt bzw.
beschleunigt werden.


Zu Anhang A, Speicherklassen
----------------------------

Das Schluesselwort 'extern' wird stets als Speicherklasse aufge-
fasst, nie zur blossen Kennzeichnung einer Vorabdeklaration. Es
ist also nicht gestattet, 'static'-Variablen mit 'extern' vorab
zu deklarieren.


Noch bekannte Fehler in Version 1.1:
------------------------------------

1. Enthaelt ein Pointer eine Adresse groesser oder gleich 8000H,
   so wird er faelschicherweise als negative Zahl betrachtet.
   Dadurch fallen Vergleiche mit diesem Pointer falsch aus.
   Ausweg: Konvertierung auf 'unsigned' und Umkehrung der Relation,
   z.B.
      char *p,*q; p=0x8800; q=0x3000;
        ...
      statt if(q<p) ...  schreibe if((unsigned)q > (unsigned)p) ...

2. Wird eine Konstante auf einen Pointertyp konvertiert, so ergibt
   die *-operation keinen l-valu@e.
   Ausweg: Zuweisung der Konstante an einen Pointer. z.B.:
     statt *(long*)0x6666 = ...   schreibe
       long *pl; ... *(pl=0x6666) = ...

3. Beim Syntaxfehler
   int a,n; b[3];
   erscheint die unsinnige Meldung "missing '}' declaration".
   Der Fehler wird aber richtig lokalisiert.

4. Die Konvertierung float->double ist falsch und kann sogar zum
   Absturz fuehren. Sie ist aber leicht zu vermeiden.

5. Bei gesetztem Schalter /I+ werden Ausdruecke der Form
   Pointer + Integer
   falsch uebersetzt.

6. Wird beim letzten Morphem einer Zeile ein Fehler erkannt und
   ist /LI:1 gesetzt, so erscheint diese Zeile doppelt.

Ich bitte alle Nutzer um eine Vervollstaendigung dieser Liste!
      putchar(' '); scanf("%s",v[actsw++]); return 1;
         case 'g': brkp=-1; return 0;
         case 's': case '\n'|0x20: brkp=0; return 0;
         case 'w': if((i=getchar()-'0')>(unsigned)actsw-1) break;
            